import httplib
from urlparse import urlunparse
from urllib import quote


def message_path(archive_name, message_id):
    return '/%s/%s' % (quote(archive_name), quote(message_id))


class GrackleClient:

    def __init__(self, host, port):
        self.host = host
        self.port = port

    def message_url(self, archive_name, message_id):
        netloc = '%s:%d' % (self.host, self.port)
        path = message_path(archive_name, message_id)
        return urlunparse(('http', netloc, path, '', '', ''))

    def put_message(self, archive_name, message_id, file_obj):
        url = self.message_url(archive_name, message_id)
        connection = httplib.HTTPConnection(self.host, self.port)
        connection.request('PUT', url, file_obj.read())
        response = connection.getresponse()
        data = response.read()
        if response.status == httplib.BAD_REQUEST:
            raise Exception('wtf')
        elif response.status == httplib.CREATED:
            return
        else:
            raise Exception('!!')
